/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.2
import Ubuntu.Components 1.1
import Ubuntu.Components.ListItems 1.0 as ListItem
import TrojitaCore 0.1
import DekkoCore 0.1

Page {
    id: accountsPage
    title: i18n.tr("Accounts")

    flickable: accountsListView

    signal openAccount(string accountName)

    head.actions: [
        Action {
            id: addAccountAction
            iconName: "contact-new"
            visible: accountsListModel.count
            onTriggered: {
                pageStack.clear()
                currentAccount.reset()
                imapPasswordWatcher.clearCurrentPassword()
                smtpPasswordWatcher.clearCurrentPassword()
                pageStack.push(Qt.resolvedUrl("../Settings/SettingsTabs.qml"), {newAccount: true})
                pageStack.push(Qt.resolvedUrl("../Settings/AddNewAccountPage.qml"))
            }
        }
    ]
    AccountsListView {
        id: accountsListView
        anchors.fill: parent
    }

    Label {
        id: label
        visible: !accountsListModel.count
        anchors.centerIn: parent
        text: i18n.tr("You currently have no accounts configured.")
    }
    Button {
        anchors {
            top: label.bottom
            topMargin: units.gu(2)
            horizontalCenter: parent.horizontalCenter
        }
        visible: label.visible
        text: i18n.tr("Add Account")
        color: "green"
        width: units.gu(25)
        onClicked: addAccountAction.trigger()
    }


}
