/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.0
import Ubuntu.Components 1.1
import Ubuntu.Components.Popups 1.0
import "../Components"
import "../Dialogs"

PageHeadConfiguration {
    id: topContainer

    // Signals
    signal sendClicked
    signal cancelClicked
    signal loseFocus
    signal draftsClicked

    Action {
        id: draftsAction
        text: i18n.tr("Drafts")
        onTriggered: {
            draftsClicked()
        }
        iconName: "edit"
    }

    Action {
        id: sendAction
        text: i18n.tr("Send")
        onTriggered: {
            sendClicked()
        }

        iconSource: Qt.resolvedUrl("../../icons/email.svg")
    }

    Action {
        id: addAttachmentAction
        text: i18n.tr("Add attachment")
        iconName: "attachment"
        onTriggered: {
            var contentDialog = PopupUtils.open(Qt.resolvedUrl("../Dialogs/ContentPickerDialog.qml"), dekko, {
                                                    isExport: false
                                                });
            contentDialog.filesImported.connect(
                function(files) {
                    for (var i in files) {
                        submissionManager.attachmentsModel.addAttachment(files[i].url.toString().replace("file://", ""));
                    }
                }
            );
        }
    }

    Action {
        id: closeAction
        text: i18n.tr("Cancel")
        onTriggered: {
            cancelClicked()
        }
        iconName: "close"
    }

    backAction: closeAction
    actions: [
        sendAction,
        draftsAction,
        addAttachmentAction
    ]
}
