/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.0
import Ubuntu.Components 1.1
import Ubuntu.Components.ListItems 1.0 as ListItems
import "../Components"
import "../Utils/Utils.js" as Utils
import TrojitaCore 0.1
import DekkoCore 0.1

Page {
    id: messageListPage
    title: i18n.tr("Messages")
    flickable: null
    tools: messageListToolbar

    //-----------------------------------
    // PROPERTIES
    //-----------------------------------
    property string mailBox: messageListPage.title
    property bool indexValid: imapAccess.msgListModel ? imapAccess.msgListModel.itemsValid : true

    //----------------------------------
    // COMPONENTS
    //----------------------------------

    MessagesListView {
        id: messagesListView
        height: parent.height
        width: parent.width
        clip: true
    }

    MessageListToolbar {
        id: messageListToolbar
    }

    TaskProgressBar {
        anchors.bottom: parent.bottom
    }
}
