/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.2
import Ubuntu.Components 1.1
import Ubuntu.Components.Popups 1.0
import Ubuntu.Web 0.2
import DekkoCore 0.1

WebView {
    id: dekkoWebView
    height: messageView.heightLeftForMessageContent
    width: parent.width
    //property alias messageUrl: dekkoWebView.url
    //property string messageContent
    property bool useDefaultContentSize: true
    property bool permissionToDownload: false

    signal permissionRequested
    signal linkClicked(variant requestUrl)

    property alias msgPartIndex: plainTextFormatter.msgPartIndex

    //swtich section while webview is scrolling will crash
    function disableSectionForAWhile() {
        oneMessagePage.head.sections.enabled = false;
        enableSectionTimer.restart();
    }

    onContentXChanged: disableSectionForAWhile();
    onContentYChanged: disableSectionForAWhile();

    Timer {
        id: enableSectionTimer
        interval: 1000
        repeat: false
        onTriggered: oneMessagePage.head.sections.enabled = true;
    }

    PlainTextFormatter {
        id: plainTextFormatter
        msgIndex: imapAccess.oneMessageModel.messageIndex
        format: PlainTextFormatter.PLAIN
        onMessageChanged: {
            dekkoWebView.loadHtml(rawMessage);
        }
    }

//    Action {
//        id: openUrl
//        onTriggered: Qt.openUrlExternally()
//    }

    onNavigationRequested: {
        linkClicked(request.url);
        request.action = 255; //255 == OxideQNavigationRequest::ActionReject
//        //console.log("Navigation requested " + request.navigationType)
//        if (request.navigationType === WebView.LinkClickedNavigation) {
//            request.action = WebView.IgnoreRequest
//            //TODO: handle the options in MailPreferences
//            linkClicked(request.url)
//        } else {
//            console.log("URL: " + request.url)
//            var trojiaScheme = /trojita-imap\:\/\/msg/;
//            var dataScheme = /data\:/;
//            var cidScheme = /cid\:/;
//            var aboutScheme = /about\:blank/
//            var externScheme = /^(http|https):/
//            if (trojiaScheme.test(request.url)) {
//                console.log("trojita-imap scheme requested")
//                request.action = WebView.AcceptRequest;
//            } else if (dataScheme.test(request.url)) {
//                console.log("data: url scheme requested")
//                request.action = WebView.AcceptRequest;
//            } else if (cidScheme.test(request.url)) {
//                console.log("cid: url scheme requested");
//                request.action = WebView.AcceptRequest;
//            } else if (aboutScheme.test(request.url)) {
//                console.log("about:blank url scheme requested")
//                request.action = WebView.AcceptRequest;
//            // Lets just ignore all external requests here
//            // as they aren't supported just yet. But it's better to display what we can of an html
//            // part which usually contains all the text and usually just wants to download images etc

//            // TODO: one supported enable the permissionRequested signal again
//            } else if (externScheme.test(request.url)) {
//                if (permissionToDownload) {
//                    request.action = WebView.AcceptRequest;
//                    permissionToDownload = false;
//                } else {
//                    request.action = WebView.IgnoreRequest;
////                    permissionRequested(request.url)
//                }
//            } else {
//                request.action = WebView.IgnoreRequest;
//            }
//        }
    }

//    Component.onCompleted: {
//        // Lets do this here as it can't be changed while the message
//        // is open so better to set it ASAP.
//        if (imapAccess.autoLoadImages) {
//            experimental.preferences.autoLoadImages = true
//        } else {
//            // lets just make sure it's false, maybe one call too many but at this point
//            // better to be safe than sorry.
//            experimental.preferences.autoLoadImages = false
//        }
////        linkClicked.connect(oneMessagePage.openUrlExternally)
//    }

//    url: messageUrl

//    experimental {
//        preferences {
//            navigatorQtObjectEnabled: false
//            developerExtrasEnabled: false
//            javascriptEnabled: false
//            privateBrowsingEnabled: true
//            localStorageEnabled: false
//        }
//        preferredMinimumContentsWidth: 0

//        urlSchemeDelegates: [
//            UrlSchemeDelegate {
//                scheme: "trojita-imap"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            },
//            UrlSchemeDelegate {
//                scheme: "http"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            },
//            UrlSchemeDelegate {
//                scheme: "https"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            },
//            UrlSchemeDelegate {
//                scheme: "data"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            },
//            UrlSchemeDelegate {
//                scheme: "cid"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            },
//            UrlSchemeDelegate {
//                scheme: "about"
//                onReceivedRequest: {
//                    imapAccess.msgQNAM.wrapQmlWebViewRequest(request, reply)
//                }
//            }
//        ]
//    }
}
