/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.0
import Ubuntu.Components 1.1
import Ubuntu.Components.ListItems 1.0 as ListItem
import DekkoCore 0.1
import "../Composer"


Page {
    id: senderIdentities
    flickable: null
    signal updateIdentity
    head.actions: [
        Action {
            id: save
            iconName: "save"
            onTriggered: {
                if (state === "new") {
                    identityInput.save()
                    pageStack.pop()
                } else {
                    updateIdentity()
                }
            }
        }
    ]
    state: "new"
    states: [
        State {
            name: "new"
            PropertyChanges {
                target: senderIdentities
                title: i18n.tr("New Identity")
            }
        },
        State {
            name: "edit"
            PropertyChanges {
                target: senderIdentities
                title: i18n.tr("Edit Identity")
            }
        }
    ]

    property Account account
    property int index
    property alias name: identityInput.nameField
    property alias email: identityInput.emailField
    property alias org: identityInput.organizationField
    property alias sig: identityInput.signatureField

    SenderIdentityInput {
        id: identityInput
        anchors.fill: parent
    }

}
