/* Copyright (C) 2014 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef SENDERIDENTITY_H
#define SENDERIDENTITY_H

#include <QObject>

namespace Dekko
{
namespace Accounts
{

class SenderIdentity : public QObject
{
    Q_OBJECT

    Q_PROPERTY(QString name READ name WRITE setName NOTIFY dataChanged)
    Q_PROPERTY(QString email READ email WRITE setEmail NOTIFY dataChanged)
    Q_PROPERTY(QString organization READ organization WRITE setOrganization NOTIFY dataChanged)
    Q_PROPERTY(QString signature READ signature WRITE setSignature NOTIFY dataChanged)
    Q_PROPERTY(bool useDefaultSignature READ useDefaultSignature WRITE setUseDefaultSignature NOTIFY dataChanged)
public:
    explicit SenderIdentity(QObject *parent = 0);
    ~SenderIdentity(){ this->deleteLater(); }

    QString name() const;
    void setName(const QString &name);
    QString email() const;
    void setEmail(const QString &email);
    QString organization()const;
    void setOrganization(const QString &org);
    QString signature() const;
    void setSignature(const QString &signature);
    bool useDefaultSignature() const;
    void setUseDefaultSignature(const bool shouldUse);

    Q_INVOKABLE QString toFormattedString();

signals:
    void dataChanged();

private:
    QString m_name;
    QString m_email;
    QString m_organization;
    QString m_signature;
    bool m_useDefaultSignature;

    QString getDefaultSignature() const;

};
}
}
#endif // SENDERIDENTITY_H
