#ifndef MAILCONFIG_H
#define MAILCONFIG_H

#include "MSA/Account.h"
namespace Dekko
{

class MailConfig : public QObject{
    Q_OBJECT
    Q_PROPERTY(QString imapHost READ imapHost)
    Q_PROPERTY(int imapPort READ imapPort)
    Q_PROPERTY(QString imapMethod READ imapMethod)
    Q_PROPERTY(QString smtpHost READ smtpHost)
    Q_PROPERTY(int smtpPort READ smtpPort)
    Q_PROPERTY(int smtpMethod READ smtpMethod)
public:
    QString imapHost() const;
    void setImapHost(const QString &imapHost);

    int imapPort() const;
    void setImapPort(int imapPort);

    QString imapMethod() const;
    void setImapMethod(const QString &imapMethod);

    QString smtpHost() const;
    void setSmtpHost(const QString &smtpHost);

    int smtpPort() const;
    void setSmtpPort(int smtpPort);

    int smtpMethod() const;
    void setSmtpMethod(const MSA::Account::Method &smtpMethod);

    void clear();
    void print();
private:
    QString m_imapHost;
    int m_imapPort;
    QString m_imapMethod; // No, StartTLS, SSL

    QString m_smtpHost;
    int m_smtpPort;
    MSA::Account::Method m_smtpMethod;
};

}
#endif
