#include <QQuickItem>
#include <QModelIndex>
#include <UiUtils/PartWidgetFactory.h>
namespace Dekko {

namespace PartWidget {

class LoadablePartWidget: public QObject {
    Q_OBJECT
public:
    // LoadablePartWidget is owned by messageView
    LoadablePartWidget(QQuickItem *messageView, const QModelIndex &partIndex,
                       UiUtils::PartWidgetFactory *factory,
                       int recursionDepth,
                       const UiUtils::PartWidgetFactory::PartLoadingOptions loadingOptions,
                       QQmlEngine *qmlEngine);
    QQuickItem *createItem();
public slots:
    void handleLoadContent();
private:
    QQuickItem *m_messageView;
    QQuickItem *m_item;
    const QModelIndex m_partIndex;
    UiUtils::PartWidgetFactory *m_factory;
    int m_recursionDepth;
    const UiUtils::PartWidgetFactory::PartLoadingOptions m_loadingOptions;
    QQmlEngine *m_qmlEngine;
};

}
}
